<template lang="pug">
.row.justify-center.items-center
  .col-auto.relative-position.text-center(style='width: 100px')
    q-knob.absolute-center(
      v-model='newInterest',
      disable,
      :max='maxInterest',
      size='60px',
      color='green',
      :thickness='1'
    )
    q-btn(push, round, icon='thumb_up', color='green', @click='tagInterest', style='width: 50px; height: 50px')
      q-tooltip Keep pushing to indicate that this might be of interest later
  .col-auto
    q-btn(
      push,
      round,
      icon='thumb_down',
      color='grey-7',
      @click='clearInterest',
      size='sm',
      :disable='newInterest == 0'
    )
      q-tooltip Indicate this is no longer interesting
</template>

<script>
export default {
  name: 'Dashboard',
  props: {
    firebase: {
      required: true,
    },
    context: {
      required: false,
    },
  },
  components: {},
  data: () => {
    return {
      config: null,
      newInterest: 0,
      maxInterest: 20,
    };
  },
  computed: {},
  created() {
    setInterval(async () => {
      if (this.config) {
        // console.log(this.config);
        const currentPlugins = Object.keys(this.config.currentState.plugins);

        if (currentPlugins.indexOf('tagging') >= 0 && this.newInterest > 0) {
          const timestamp = Date.now();
          // const newInterest = this.series[1] >= 1 ? this.series[1] - 1 : 0;
          this.newInterest -= 2;
          // console.log(this.newInterest);
          // this.series = [20 - newInterest, newInterest];
          // console.log('this.series: ', this.series);
          await this.pushTaggingData(timestamp, this.newInterest);
        }
      }
    }, 2000);
  },
  methods: {
    async pushTaggingData(timestamp, data) {
      await this.firebase.ref(`data/tagging/${this.context.meetingid}`).push({ timestamp, data });
    },
    async tagInterest() {
      const timestamp = Date.now();
      // this.series = [0, 20];
      this.newInterest = this.maxInterest;
      // console.log('this.series: ', this.series);
      await this.pushTaggingData(timestamp, 20);
    },
    async clearInterest() {
      const timestamp = Date.now();
      this.newInterest = 0;
      // this.series = [20, 0];
      // console.log('this.series: ', this.series);
      await this.pushTaggingData(timestamp, 0);
    },
  },
  watch: {
    firebase: {
      immediate: true,
      async handler() {},
    },
  },
  async mounted() {
    await this.$rtdbBind('config', this.firebase.ref(`config/${this.context.meetingid}/current`));
    // console.log(this.config.currentState.plugins);
    this.maxInterest = this.config.currentState.plugins?.tagging?.timeout ?? 20;
  },
};
</script>

<style lang="sass" scoped>
</style>
